<template>
    <div class="edit-popup">
        <el-card class="!border-none" shadow="never">
            <el-page-header :content="$route.meta.title" @back="$router.back()" />
        </el-card>
        <el-card class="mt-4 !border-none" shadow="never">
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="试题分类" prop="category_uid">
                    <el-cascader
                        v-model="formData.category_uid"
                        :options="optionsData.category"
                        :props="props"
                        @change="handleChange"
                        style='width: 100%'
                    />
                </el-form-item>
                <el-form-item label="试题题干" prop="title">
                    <el-input v-model="formData.title" clearable placeholder="请输入试题题干" />
                </el-form-item>
                <el-form-item label="收藏数量" prop="collect">
                    <div>
                        <el-input-number v-model="formData.collect" :min="0" />
                        <div class="form-tips">默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item>
                <el-form-item label="答题人数" prop="submit">
                    <div>
                        <el-input-number v-model="formData.submit" :min="0" />
                        <div class="form-tips">默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item>
                <el-form-item label="试题积分" prop="score">
                    <el-input-number
                        v-model="formData.score"
                        clearable
                        placeholder="请输入试题积分"
                        :precision="2"
                        :step="0.1"
                        :max="100"
                    />
                </el-form-item>
                <el-form-item label="试题难度" prop="level">
                    <el-select
                        class="flex-1"
                        v-model="formData.level"
                        clearable
                        placeholder="请选择试题难度"
                    >
                        <el-option
                            v-for="(item, index) in dictData.exam_level"
                            :key="index"
                            :label="item.name"
                            :value="parseInt(item.value)"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="显示状态" prop="is_show">
                    <el-radio-group v-model="formData.is_show" placeholder="请选择显示状态">
                        <el-radio
                            v-for="(item, index) in dictData.show_status"
                            :key="index"
                            :label="parseInt(item.value)"
                        >
                            {{ item.name }}
                        </el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="显示权重" prop="sort">
                    <div>
                        <el-input-number v-model="formData.sort" :min="0" />
                        <div class="form-tips">默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item>
                <el-form-item label="收费状态" prop="is_free">
                    <el-select
                        class="flex-1"
                        v-model="formData.is_free"
                        clearable
                        placeholder="请选择收费状态"
                    >
                        <el-option
                            v-for="(item, index) in dictData.free_status"
                            :key="index"
                            :label="item.name"
                            :value="parseInt(item.value)"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="试题答案" prop="content">
                    <editor class="flex-1" v-model="formData.content" :height="auto" />
                </el-form-item>
            </el-form>
        </el-card>
        <footer-btns>
            <el-button type="primary" @click="handleSave">保存</el-button>
        </footer-btns>
    </div>
</template>

<script lang="ts" setup name="examReadingEdit">
import type { FormInstance } from 'element-plus'
import { useDictOptions, useDictData } from '@/hooks/useDictOptions'
import { apiExamReadingAdd, apiExamReadingEdit, apiExamReadingDetail } from '@/api/exam_reading'
import type { PropType } from 'vue'
import { apiExamCategoryTree } from '@/api/exam_category'

const route = useRoute()
const router = useRouter()

defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const formRef = shallowRef<FormInstance>()

// 表单数据
const formData = reactive({
    id: '',
    title: '',
    is_show: 1,
    sort: 0,
    is_free: '',
    content: '',
    category_uid: '',
    submit: 0,
    collect: 0,
    score: 1.0,
    level: ''
})

// 表单验证
const formRules = reactive<any>({
    title: [
        {
            required: true,
            message: '请输入试题题干',
            trigger: ['blur']
        }
    ],
    is_show: [
        {
            required: true,
            message: '请选择显示状态',
            trigger: ['blur']
        }
    ],
    sort: [
        {
            required: true,
            message: '请输入显示顺序',
            trigger: ['blur']
        }
    ],
    is_free: [
        {
            required: true,
            message: '请选择收费状态',
            trigger: ['blur']
        }
    ],
    content: [
        {
            required: true,
            message: '请输入试题答案',
            trigger: ['blur']
        }
    ],
    submit: [
        {
            required: true,
            message: '请输入提交人数',
            trigger: ['blur']
        }
    ],
    collect: [
        {
            required: true,
            message: '请输入收藏人数',
            trigger: ['blur']
        }
    ],
    score: [
        {
            required: true,
            message: '请输入试题积分',
            trigger: ['blur']
        }
    ],
    level: [
        {
            required: true,
            message: '请选择试题难度',
            trigger: ['blur']
        }
    ]
})

// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
}

const { dictData } = useDictData('show_status,free_status,exam_level')

const handleChange = (value) => {
    formData.category_uid = value[1]
}
const getDetail = async (row: Record<string, any>) => {
    const data = await apiExamReadingDetail({
        id: route.query.id
    })
    setFormData(data)
}

const { optionsData } = useDictOptions<{
    category: any[]
}>({
    category: {
        api: apiExamCategoryTree
    }
})

// 提交按钮
const handleSave = async () => {
    await formRef.value?.validate()
    if (route.query.id) {
        await apiExamReadingEdit(formData)
    } else {
        await apiExamReadingAdd(formData)
    }
    router.back()
}

route.query.id && getDetail()
</script>
